VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   4185
   ClientLeft      =   1140
   ClientTop       =   1515
   ClientWidth     =   4935
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   4185
   ScaleWidth      =   4935
   Begin VB.TextBox txtInput 
      Height          =   285
      Left            =   480
      TabIndex        =   9
      Text            =   "123456789012345.12345678912345"
      Top             =   2880
      Width           =   2895
   End
   Begin VB.Frame Frame1 
      Caption         =   "Overrides"
      Height          =   2415
      Left            =   0
      TabIndex        =   13
      Top             =   360
      Width           =   4935
      Begin VB.ComboBox cboNegativeOrder 
         Height          =   315
         ItemData        =   "Form1.frx":0000
         Left            =   1920
         List            =   "Form1.frx":0013
         Style           =   2  'Dropdown List
         TabIndex        =   8
         Top             =   2040
         Width           =   735
      End
      Begin VB.TextBox txtNumPerGroup 
         Height          =   285
         Left            =   1920
         TabIndex        =   4
         Text            =   "3"
         Top             =   600
         Width           =   255
      End
      Begin VB.TextBox txtDecimal 
         Height          =   285
         Left            =   1920
         TabIndex        =   5
         Text            =   "."
         Top             =   960
         Width           =   255
      End
      Begin VB.TextBox txtThousands 
         Height          =   285
         Left            =   1920
         TabIndex        =   6
         Text            =   ","
         Top             =   1320
         Width           =   255
      End
      Begin VB.TextBox txtDigits 
         Height          =   285
         Left            =   1920
         TabIndex        =   3
         Text            =   "5"
         Top             =   240
         Width           =   375
      End
      Begin VB.CheckBox chkLeadingZero 
         Alignment       =   1  'Right Justify
         Caption         =   "Leading Zero"
         Height          =   255
         Left            =   240
         TabIndex        =   7
         Top             =   1680
         Width           =   1900
      End
      Begin VB.Label Label1 
         AutoSize        =   -1  'True
         Caption         =   "Negative Order"
         Height          =   195
         Index           =   4
         Left            =   240
         TabIndex        =   18
         Top             =   2040
         Width           =   1080
      End
      Begin VB.Label Label1 
         AutoSize        =   -1  'True
         Caption         =   "Digits Per Grouping"
         Height          =   195
         Index           =   1
         Left            =   240
         TabIndex        =   17
         Top             =   600
         Width           =   1365
      End
      Begin VB.Label Label1 
         AutoSize        =   -1  'True
         Caption         =   "Decimal Separator"
         Height          =   195
         Index           =   2
         Left            =   240
         TabIndex        =   16
         Top             =   960
         Width           =   1305
      End
      Begin VB.Label Label1 
         AutoSize        =   -1  'True
         Caption         =   "Thousands Separator"
         Height          =   195
         Index           =   3
         Left            =   240
         TabIndex        =   15
         Top             =   1320
         Width           =   1530
      End
      Begin VB.Label Label1 
         AutoSize        =   -1  'True
         Caption         =   "Decimal Digits"
         Height          =   195
         Index           =   5
         Left            =   240
         TabIndex        =   14
         Top             =   240
         Width           =   1005
      End
   End
   Begin VB.OptionButton optLocale 
      Caption         =   "System Default"
      Height          =   255
      Index           =   0
      Left            =   720
      TabIndex        =   0
      Tag             =   "&H400"
      Top             =   0
      Width           =   1455
   End
   Begin VB.OptionButton optLocale 
      Caption         =   "User Default"
      Height          =   255
      Index           =   1
      Left            =   2160
      TabIndex        =   1
      Tag             =   "&H800"
      Top             =   0
      Width           =   1335
   End
   Begin VB.OptionButton optLocale 
      Caption         =   "Use Overrides"
      Height          =   255
      Index           =   2
      Left            =   3480
      TabIndex        =   2
      Tag             =   "0"
      Top             =   0
      Width           =   1335
   End
   Begin VB.CommandButton cmdFormat 
      Caption         =   "Format"
      Default         =   -1  'True
      Height          =   375
      Left            =   2040
      TabIndex        =   10
      Top             =   3360
      Width           =   855
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Value"
      Height          =   195
      Index           =   0
      Left            =   0
      TabIndex        =   19
      Top             =   2880
      Width           =   405
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Locale:"
      Height          =   195
      Index           =   6
      Left            =   0
      TabIndex        =   12
      Top             =   0
      Width           =   525
   End
   Begin VB.Label lblResult 
      Height          =   315
      Left            =   0
      TabIndex        =   11
      Top             =   3840
      Width           =   4965
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Type NUMBERFMT
    NumDigits As Long
    LeadingZero As Long
    Grouping As Long
    lpDecimalSep As String
    lpThousandSep As String
    NegativeOrder As Long
End Type

Private Declare Function GetNumberFormat Lib "kernel32" Alias "GetNumberFormatA" (ByVal Locale As Long, ByVal dwFlags As Long, ByVal lpValue As String, lpFormat As Any, ByVal lpNumberStr As String, ByVal cchNumber As Long) As Long

Private m_Locale As Long

Private Const LOCALE_SYSTEM_DEFAULT = &H400
Private Const LOCALE_USER_DEFAULT = &H800
Private Const LOCALE_NOUSEROVERRIDE = &H80000000

' Format the text.
Private Sub cmdFormat_Click()
    lblResult.Caption = _
        FormatString(txtInput.Text, _
            m_Locale, _
            CInt(txtDigits.Text), _
            chkLeadingZero.Value = vbChecked, _
            CInt(txtNumPerGroup.Text), _
            txtDecimal.Text, _
            txtThousands.Text, _
            cboNegativeOrder.ListIndex)
End Sub

' Format a numeric string.
Private Function FormatString(ByVal numeric_string As String, ByVal locale_id As Long, ByVal num_digits As Integer, ByVal leading_zero As Boolean, ByVal num_per_group As Integer, ByVal decimal_separator As String, ByVal thousands_separator As String, ByVal negative_order As Long) As String
Dim fmt As NUMBERFMT
Dim buf As String * 200
Dim buflen As Integer

    With fmt
        .NumDigits = num_digits
        If leading_zero Then
            .LeadingZero = 1
        Else
            .LeadingZero = 0
        End If
        .Grouping = num_per_group
        .lpDecimalSep = decimal_separator
        .lpThousandSep = thousands_separator
        .NegativeOrder = negative_order
    End With

    If locale_id = 0 Then
        buflen = GetNumberFormat(locale_id, 0, _
            numeric_string, fmt, buf, Len(buf))
    Else
        buflen = GetNumberFormat(locale_id, 0, _
            numeric_string, ByVal 0&, buf, Len(buf))
    End If

    FormatString = Left$(buf, buflen)
End Function
Private Sub Form_Load()
    optLocale(0).Value = True
    cboNegativeOrder.ListIndex = 1
End Sub


Private Sub optLocale_Click(Index As Integer)
    m_Locale = CInt(optLocale(Index).Tag)

Dim enable As Boolean
Dim ctl As Control

    enable = (m_Locale = 0)
    Frame1.Enabled = enable
    For Each ctl In Controls
        If ctl.Container Is Frame1 Then
            ctl.Enabled = enable
        End If
    Next ctl
End Sub
